package juliac.generated;

import java.lang.annotation.Annotation;
import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.julia.ComponentInterface;
import org.objectweb.fractal.api.type.ComponentType;
import org.ow2.frascati.tinfi.control.content.scope.CompositeScopeManager;
import java.lang.reflect.Constructor;
import org.ow2.frascati.tinfi.control.content.ContentClassMetaData;
import org.ow2.frascati.tinfi.api.control.ContentInstantiationException;
import org.objectweb.fractal.julia.Controller;
import org.ow2.frascati.tinfi.osoa.ConversationScopeManager;
import org.objectweb.fractal.julia.loader.Generated;
import java.util.HashMap;
import org.ow2.frascati.tinfi.control.content.IllegalContentClassMetaData;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.fractal.julia.InitializationContext;
import org.ow2.frascati.tinfi.reflect.InjectionPoint;
import org.ow2.frascati.tinfi.reflect.InjectionPointMap;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.objectweb.fractal.julia.Interceptor;
import org.objectweb.fractal.api.Interface;
import org.objectweb.fractal.api.type.InterfaceType;
import java.lang.reflect.InvocationTargetException;
import org.objectweb.fractal.api.control.LifeCycleController;
import java.util.List;
import java.util.Map;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.oasisopen.sca.annotation.Property;
import org.oasisopen.sca.RequestContext;
import org.ow2.frascati.tinfi.osoa.RequestScopeManager;
import org.ow2.frascati.tinfi.api.control.SCAContentController;
import org.ow2.frascati.tinfi.control.content.SCAExtendedContentController;
import org.ow2.frascati.tinfi.control.content.scope.ScopeManager;
import org.oasisopen.sca.ServiceReference;
import org.ow2.frascati.tinfi.oasis.ServiceReferenceImpl;
import java.util.Set;
import org.ow2.frascati.tinfi.control.content.scope.StatelessScopeManager;
import org.ow2.frascati.tinfi.TinfiComponentOutInterface;
import org.ow2.frascati.tinfi.TinfiRuntimeException;
import org.objectweb.fractal.api.Type;

/** 
 * @see org.objectweb.fractal.julia.BasicControllerMixin
 * @see org.ow2.frascati.tinfi.control.content.RequestContextSCAContentMixin
 * @see org.objectweb.fractal.julia.UseComponentMixin
 * @see org.ow2.frascati.tinfi.control.content.SCAContentControllerMixin
 * @see org.ow2.frascati.tinfi.control.content.TypeCheckSCAContentMixin
 * @see org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin
 * @see org.ow2.frascati.tinfi.control.content.LifeCycleSCAContentMixin
 */
public class SCAContentControllerImpl implements Controller , Generated , SCAContentController , SCAExtendedContentController {
    /** 
     * @see org.ow2.frascati.tinfi.control.content.RequestContextSCAContentMixin#tl
     */
    private ThreadLocal<org.oasisopen.sca.RequestContext>  tl = new ThreadLocal<org.oasisopen.sca.RequestContext> ();
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.LifeCycleSCAContentMixin#setFcContentClass(java.lang.Class)
     */
    public void setFcContentClass(Class<?>  c) throws IllegalLifeCycleException, ContentInstantiationException {
        String state = weaveableOptLC.getFcState();
        if (!(state.equals(LifeCycleController.STOPPED))) {
            String msg = "Component should be stopped";
            throw new IllegalLifeCycleException(msg);
        } 
        setFcContentClass$0(c);
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.TypeCheckSCAContentMixin#setFcContentClass(java.lang.Class)
     */
    private void setFcContentClass$0(Class<?>  c) throws IllegalLifeCycleException, ContentInstantiationException {
        Type type = weaveableC.getFcType();
        checkType(type ,c);
        setFcContentClass$1(c);
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.RequestContextSCAContentMixin#setRequestContext(org.oasisopen.sca.RequestContext)
     */
    public void setRequestContext(RequestContext rc) {
        tl.set(rc);
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.TypeCheckSCAContentMixin#setFcContent(java.lang.Object)
     */
    private void setFcContent$0(Object content) throws IllegalLifeCycleException, ContentInstantiationException {
        Type type = weaveableC.getFcType();
        Class<?>  c = content.getClass();
        checkType(type ,c);
        setFcContent$1(content);
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.RequestContextSCAContentMixin#getRequestContext()
     */
    public RequestContext getRequestContext() {
        RequestContext rc = tl.get();
        return rc;
    }
    
    /** 
     * @see org.objectweb.fractal.julia.UseComponentMixin#weaveableC
     */
    public Component weaveableC;
    
    /** 
     * @see org.objectweb.fractal.julia.BasicControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$2(final InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.LifeCycleSCAContentMixin#setFcContent(java.lang.Object)
     */
    public void setFcContent(Object content) throws IllegalLifeCycleException, ContentInstantiationException {
        String state = weaveableOptLC.getFcState();
        if (!(state.equals(LifeCycleController.STOPPED))) {
            String msg = "Component should be stopped";
            throw new IllegalLifeCycleException(msg);
        } 
        setFcContent$0(content);
    }
    
    /** 
     * @see org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin#weaveableOptLC
     */
    public LifeCycleController weaveableOptLC;
    
    /** 
     * @see org.objectweb.fractal.julia.UseComponentMixin#weaveableOptC
     */
    public Component weaveableOptC;
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.TypeCheckSCAContentMixin#checkType(org.objectweb.fractal.api.Type,java.lang.Class)
     */
    private void checkType(Type type, Class<?>  contentClass) throws ContentInstantiationException {
        ComponentType ct = ((ComponentType)(type));
        InterfaceType[] its = ct.getFcInterfaceTypes();
        for (InterfaceType it : its) {
            if (it.isFcClientItf()) {
                continue;
            } 
            String name = it.getFcItfName();
            if ((name.equals("component")) || (name.endsWith("-controller"))) {
                continue;
            } 
            String signature = it.getFcItfSignature();
            if (contentClass.equals(Object.class)) {
                String msg = "Object.class is not adequate since the content class should implement " + signature;
                throw new ContentInstantiationException(msg);
            } 
            Class<?>  cl = load(contentClass ,signature);
            if (!(cl.isAssignableFrom(contentClass))) {
                String msg = (contentClass + " should implement ") + signature;
                throw new ContentInstantiationException(msg);
            } 
        }
    }
    
    /** 
     * @see org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    public void initFcController(final InitializationContext ic) throws InstantiationException {
        weaveableOptLC = ((LifeCycleController)(ic.getOptionalInterface("lifecycle-controller")));
        initFcController$0(ic);
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.SCAContentControllerMixin#ccmd
     */
    private ContentClassMetaData ccmd;
    
    /** 
     * @see org.objectweb.fractal.julia.UseComponentMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$1(final InitializationContext ic) throws InstantiationException {
        weaveableC = ((Component)(ic.getInterface("component")));
        weaveableOptC = weaveableC;
        initFcController$2(ic);
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.SCAContentControllerMixin#sm
     */
    private ScopeManager sm;
    
    private void setFcContentClass$2(Class<?>  c) throws IllegalLifeCycleException, ContentInstantiationException {
    }
    
    private void setFcContent$2(Object content) throws IllegalLifeCycleException, ContentInstantiationException {
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.SCAContentControllerMixin#props
     */
    private Map<java.lang.String, java.lang.Class<?>>  props = new HashMap<java.lang.String, java.lang.Class<?>> ();
    
    private void initFcController$3(InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.SCAContentControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$0(final InitializationContext ic) throws InstantiationException {
        initFcController$1(ic);
        Class<?>  c = ((Class<?> )(ic.content));
        try {
            innerSetFcContentClass(c);
        } catch (IllegalContentClassMetaData eccmd) {
            InstantiationException ie = new InstantiationException(eccmd.getMessage());
            ie.initCause(eccmd);
            throw ie;
        }
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.TypeCheckSCAContentMixin#load(java.lang.Class,java.lang.String)
     */
    private Class<?>  load(Class<?>  main, String name) throws ContentInstantiationException {
        ClassLoader loader = main.getClassLoader();
        try {
            return loader.loadClass(name);
        } catch (ClassNotFoundException cnfe) {
            throw new ContentInstantiationException(cnfe);
        }
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.SCAContentControllerMixin#setFcContentClass(java.lang.Class)
     */
    private void setFcContentClass$1(Class<?>  c) throws IllegalLifeCycleException, ContentInstantiationException {
        try {
            innerSetFcContentClass(c);
        } catch (IllegalContentClassMetaData e) {
            throw new ContentInstantiationException(e);
        }
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.SCAContentControllerMixin#getFcContentClass()
     */
    public Class<?>  getFcContentClass() {
        return ccmd.fcContentClass;
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.SCAContentControllerMixin#getFcContent()
     */
    public Object getFcContent() throws ContentInstantiationException {
        return sm.getFcContent();
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.SCAContentControllerMixin#setFcContent(java.lang.Object)
     */
    private void setFcContent$1(Object content) throws IllegalLifeCycleException, ContentInstantiationException {
        sm.setFcContent(content);
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.SCAContentControllerMixin#releaseFcContent(java.lang.Object,boolean)
     */
    public void releaseFcContent(Object content, boolean isEndMethod) {
        sm.releaseFcContent(content ,isEndMethod);
        setRequestContext(null);
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.SCAContentControllerMixin#eagerInit()
     */
    public void eagerInit() throws ContentInstantiationException {
        if (!(ccmd.eagerinit)) {
            return ;
        } 
        if (!((sm) instanceof CompositeScopeManager)) {
            String msg = ("Eager initialization is meaningless in scopes other than COMPOSITE (scope is: " + (ccmd.scope)) + ")";
            throw new ContentInstantiationException(msg);
        } 
        sm.getFcContent();
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.SCAContentControllerMixin#start()
     */
    public void start() throws ContentInstantiationException {
        if ((ccmd.startMethod) == null) {
            return ;
        } 
        Object[] contents = sm.getFcCurrentContents();
        for (Object content : contents) {
            try {
                ccmd.startMethod.invoke(content);
            } catch (IllegalAccessException e) {
                throw new ContentInstantiationException(e);
            } catch (InvocationTargetException e) {
                throw new ContentInstantiationException(e);
            }
        }
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.SCAContentControllerMixin#stop()
     */
    public void stop() throws ContentInstantiationException {
        if ((ccmd.stopMethod) == null) {
            return ;
        } 
        Object[] contents = sm.getFcCurrentContents();
        for (Object content : contents) {
            try {
                ccmd.stopMethod.invoke(content);
            } catch (IllegalAccessException e) {
                throw new ContentInstantiationException(e);
            } catch (InvocationTargetException e) {
                throw new ContentInstantiationException(e);
            }
        }
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.SCAContentControllerMixin#containsPropertyName(java.lang.String)
     */
    public boolean containsPropertyName(String name) {
        boolean b = props.containsKey(name);
        return b;
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.SCAContentControllerMixin#getPropertyNames()
     */
    public String[] getPropertyNames() {
        Set<java.lang.String>  propnames = props.keySet();
        String[] names = propnames.toArray(new String[propnames.size()]);
        return names;
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.SCAContentControllerMixin#getPropertyType(java.lang.String)
     */
    public Class<?>  getPropertyType(String name) {
        Class<?>  type = props.get(name);
        return type;
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.SCAContentControllerMixin#setPropertyValue(java.lang.String,java.lang.Object)
     */
    public void setPropertyValue(String name, Object value) {
        InjectionPoint ip = ccmd.props.get(name);
        if (ip == null) {
            return ;
        } 
        Object[] contents = sm.getFcCurrentContents();
        for (Object content : contents) {
            SCAContentControllerImpl.set(ip ,content ,value);
        }
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.SCAContentControllerMixin#setReferenceValue(java.lang.String,org.oasisopen.sca.ServiceReference)
     */
    public void setReferenceValue(String name, ServiceReference<?>  value) {
        InjectionPoint ip = getInjectionPoint(name);
        if (ip == null) {
            return ;
        } 
        Class<?>  iptype = ip.getType();
        Object[] contents = sm.getFcCurrentContents();
        for (Object content : contents) {
            if (List.class.isAssignableFrom(iptype)) {
                List<org.oasisopen.sca.ServiceReference<?>>  srs = ((List<org.oasisopen.sca.ServiceReference<?>> )(SCAContentControllerImpl.get(ip ,content)));
                for (ServiceReference<?>  sr : srs) {
                    ServiceReferenceImpl<?>  sri = ((ServiceReferenceImpl<?> )(sr));
                    Object o = sri._getDelegate();
                    Interface itf = ((Interface)(o));
                    String itfname = itf.getFcItfName();
                    if (itfname.equals(name)) {
                        return ;
                    } 
                }
                srs.add(value);
                SCAContentControllerImpl.set(ip ,content ,srs);
            } else if (Map.class.isAssignableFrom(iptype)) {
                Map<java.lang.String, org.oasisopen.sca.ServiceReference<?>>  srs = ((Map<java.lang.String, org.oasisopen.sca.ServiceReference<?>> )(SCAContentControllerImpl.get(ip ,content)));
                srs.put(name ,value);
                SCAContentControllerImpl.set(ip ,content ,srs);
            } else {
                SCAContentControllerImpl.set(ip ,content ,value);
            }
        }
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.SCAContentControllerMixin#unsetReferenceValue(java.lang.String)
     */
    public void unsetReferenceValue(String name) {
        InjectionPoint ip = getInjectionPoint(name);
        if (ip == null) {
            return ;
        } 
        Class<?>  iptype = ip.getType();
        Object[] contents = sm.getFcCurrentContents();
        for (Object content : contents) {
            if (List.class.isAssignableFrom(iptype)) {
                List<org.oasisopen.sca.ServiceReference<?>>  srs = ((List<org.oasisopen.sca.ServiceReference<?>> )(SCAContentControllerImpl.get(ip ,content)));
                ServiceReference<?>  toBeRemoved = null;
                for (ServiceReference<?>  sr : srs) {
                    ServiceReferenceImpl<?>  sri = ((ServiceReferenceImpl<?> )(sr));
                    Object o = sri._getDelegate();
                    Interface itf = ((Interface)(o));
                    String itfname = itf.getFcItfName();
                    if (itfname.equals(name)) {
                        toBeRemoved = sr;
                    } 
                }
                srs.remove(toBeRemoved);
                SCAContentControllerImpl.set(ip ,content ,srs);
            } else if (Map.class.isAssignableFrom(iptype)) {
                Map<java.lang.String, org.oasisopen.sca.ServiceReference<?>>  srs = ((Map<java.lang.String, org.oasisopen.sca.ServiceReference<?>> )(SCAContentControllerImpl.get(ip ,content)));
                srs.remove(name);
                SCAContentControllerImpl.set(ip ,content ,srs);
            } else {
                SCAContentControllerImpl.set(ip ,content ,null);
            }
        }
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.SCAContentControllerMixin#innerSetFcContentClass(java.lang.Class)
     */
    private synchronized void innerSetFcContentClass(Class<?>  c) throws IllegalContentClassMetaData {
        ccmd = ContentClassMetaData.get(c);
        String scope = (ccmd.scope) == null ? null : ccmd.scope.toUpperCase();
        if ((scope == null) || (scope.equals("STATELESS"))) {
            sm = new StatelessScopeManager(weaveableC , ccmd);
        } else if (scope.equals("REQUEST")) {
            sm = new RequestScopeManager(weaveableC , ccmd);
        } else if (scope.equals("COMPOSITE")) {
            sm = new CompositeScopeManager(weaveableC , ccmd);
        } else if (scope.equals("CONVERSATION")) {
            sm = new ConversationScopeManager(weaveableC , ccmd);
        } else {
            String msg = "Unsupported scope: " + (ccmd.scope);
            throw new IllegalContentClassMetaData(msg);
        }
        props = new HashMap<java.lang.String, java.lang.Class<?>> ();
        InjectionPointMap ipm = ccmd.props;
        Set<java.lang.String>  ipnames = ipm.keySet();
        for (String ipname : ipnames) {
            InjectionPoint ip = ipm.get(ipname);
            Class<?>  type = ip.getType();
            props.put(ipname ,type);
        }
        Constructor<?>  ctr = ccmd.constructorAnnotatedElement;
        if (ctr != null) {
            Class<?> [] ptypes = ctr.getParameterTypes();
            Annotation[][] psannots = ctr.getParameterAnnotations();
            for (int i = 0 ; i < (ptypes.length) ; i++) {
                Class<?>  ptype = ptypes[i];
                Annotation[] pannots = psannots[i];
                for (Annotation pannot : pannots) {
                    if (pannot instanceof Property) {
                        Property prop = ((Property)(pannot));
                        String propname = prop.name();
                        props.put(propname ,ptype);
                    } 
                }
            }
        } 
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.SCAContentControllerMixin#getInjectionPoint(java.lang.String)
     */
    private InjectionPoint getInjectionPoint(String name) {
        ComponentType ct = ((ComponentType)(weaveableC.getFcType()));
        InterfaceType it = null;
        try {
            it = ct.getFcInterfaceType(name);
        } catch (NoSuchInterfaceException e) {
            return null;
        }
        String itname = it.getFcItfName();
        InjectionPoint ip = ccmd.refs.get(itname);
        return ip;
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.SCAContentControllerMixin#get(org.ow2.frascati.tinfi.reflect.InjectionPoint,java.lang.Object)
     */
    private static Object get(InjectionPoint ip, Object content) throws TinfiRuntimeException {
        try {
            return ip.get(content);
        } catch (IllegalAccessException e) {
            throw new TinfiRuntimeException(e);
        } catch (InvocationTargetException e) {
            throw new TinfiRuntimeException(e);
        }
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.SCAContentControllerMixin#set(org.ow2.frascati.tinfi.reflect.InjectionPoint,java.lang.Object,java.lang.Object)
     */
    private static void set(InjectionPoint ip, Object content, Object value) throws TinfiRuntimeException {
        try {
            ip.set(content ,value);
        } catch (IllegalAccessException e) {
            throw new TinfiRuntimeException(e);
        } catch (InvocationTargetException e) {
            throw new TinfiRuntimeException(e);
        }
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.SCAContentControllerMixin#getServiceReference(java.lang.Object)
     */
    protected static Object getServiceReference(Object clientItf) {
        ComponentInterface itf = ((ComponentInterface)(clientItf));
        Interceptor outInterceptor = ((Interceptor)(itf.getFcItfImpl()));
        Object delegate = outInterceptor.getFcItfDelegate();
        if (delegate == null) {
            return null;
        } 
        TinfiComponentOutInterface<?>  tcoi = ((TinfiComponentOutInterface<?> )(clientItf));
        ServiceReference<?>  sr = tcoi.getServiceReference();
        return sr;
    }
    
    public String getFcGeneratorParameters() {
        return "(org.objectweb.fractal.juliac.spoon.MixinClassGenerator juliac.generated.SCAContentControllerImpl org.objectweb.fractal.julia.BasicControllerMixin org.ow2.frascati.tinfi.control.content.RequestContextSCAContentMixin org.objectweb.fractal.julia.UseComponentMixin org.ow2.frascati.tinfi.control.content.SCAContentControllerMixin org.ow2.frascati.tinfi.control.content.TypeCheckSCAContentMixin org.objectweb.fractal.julia.control.lifecycle.UseLifeCycleControllerMixin org.ow2.frascati.tinfi.control.content.LifeCycleSCAContentMixin)";
    }
    
}

